Bug 1751216 - Review Request: xlunch - Graphical app launcher for X with minimal dependencies
Summary: Review Request: xlunch - Graphical app launcher for X with minimal dependencies
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-09-11 12:38 UTC by Artem
Modified: 2020-11-12 15:47 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)

Comment 4 Artur Frenszek-Iwicki 2019-09-15 00:19:20 UTC
>Recommends:     abattis-cantarell-fonts
>...
># Change default font to Cantarell or DejaVu otherwise it won't run
>sed -i 's!# font: OpenSans-Regular/10!font: %{_datadir}/fonts/cantarell/Cantarell-Regular.otf/11!'          default.conf
Fedora ships OpenSans (open-sans-fonts), why change this?
Also, if "otherwise it won't run", then the font package should go in Requires:, not Recommends:.

># "Error generating new entries"" for key "Exec" in group "Desktop Entry" contains a reserved character '$' outside of a quote
># error: required key "Type" in group "Desktop Entry" is not present
># https://github.com/Tomas-M/xlunch/issues/109
>#desktop-file-validate %%{buildroot}%%{_datadir}/applications/genentries.desktop
I looked at the .desktop file and I think the best way to solve this would be to extract the whole chain of commands into a helper shell script, and then just launch that script from the .desktop file.

Also, taking a look at the upstream Makefile - the files are installed using "cp". Please consider patching this (and possibly sending the patch upstream) to use "cp -p" so that file timestamps are preserved.

Comment 5 Package Review 2020-09-14 00:45:24 UTC
This is an automatic check from review-stats script.

This review request ticket hasn't been updated for some time. We're sorry
it is taking so long. If you're still interested in packaging this software
into Fedora repositories, please respond to this comment clearing the
NEEDINFO flag.

You may want to update the specfile and the src.rpm to the latest version
available and to propose a review swap on Fedora devel mailing list to increase
chances to have your package reviewed. If this is your first package and you
need a sponsor, you may want to post some informal reviews. Read more at
https://fedoraproject.org/wiki/How_to_get_sponsored_into_the_packager_group.

Without any reply, this request will shortly be considered abandoned
and will be closed.
Thank you for your patience.

Comment 6 Robert-André Mauchin 🐧 2020-10-05 20:13:07 UTC
 - Is there files in this? That you would need to %config(noreplace)?

%{_sysconfdir}/%{name}

Comment 7 Artem 2020-10-06 04:37:31 UTC
(In reply to Artur Frenszek-Iwicki from comment #4)
> Fedora ships OpenSans (open-sans-fonts), why change this?

Because of consistency and Cantarell more system-widely used also canonical for GNOME DE. Just wanted better defaults. But if you insist i'll accept this easy since and we can keep upstream defaults here.

> Also, if "otherwise it won't run", then the font package should go in
> Requires:, not Recommends:.

Good point. Now 'abattis-cantarell-fonts' hard dep and there should'n be any issue since it availablin even in CentOS7 http://mirror.centos.org/centos/7/os/x86_64/Packages/abattis-cantarell-fonts-0.0.25-1.el7.noarch.rpm
 
> ># "Error generating new entries"" for key "Exec" in group "Desktop Entry" contains a reserved character '$' outside of a quote
> ># error: required key "Type" in group "Desktop Entry" is not present
> ># https://github.com/Tomas-M/xlunch/issues/109
> >#desktop-file-validate %%{buildroot}%%{_datadir}/applications/genentries.desktop
> I looked at the .desktop file and I think the best way to solve this would
> be to extract the whole chain of commands into a helper shell script, and
> then just launch that script from the .desktop file.

I though this as well, but TBH i've lost interest a little bit to this package since i've packaged Ulauncher and sgtk-menu for Fedora. But i fixed that and upstreamed, see links in SPEC file.

> Also, taking a look at the upstream Makefile - the files are installed using
> "cp". Please consider patching this (and possibly sending the patch
> upstream) to use "cp -p" so that file timestamps are preserved.

Ok, this is in TODO area.


(In reply to Robert-André Mauchin 🐧 from comment #6)
>  - Is there files in this? That you would need to %config(noreplace)?
> 
> %{_sysconfdir}/%{name}

Yep. Fixed. Also this a directory, so now this look like this:

%config(noreplace) %{_sysconfdir}/%{name}/

---

https://download.copr.fedorainfracloud.org/results/atim/xlunch/fedora-33-x86_64/01695721-xlunch/xlunch.spec
https://download.copr.fedorainfracloud.org/results/atim/xlunch/fedora-33-x86_64/01695721-xlunch/xlunch-4.5.4-1.fc33.src.rpm

There is still some issues (new) but it works.

Comment 9 Robert-André Mauchin 🐧 2020-11-05 07:36:50 UTC
 - I'm not sure this can work on directories. Could you do:


%dir %{_sysconfdir}/%{name}/
%config(noreplace) %{_sysconfdir}/%{name}/*

 - There's an issue with entries.dsv


xlunch.x86_64: E: non-readable /etc/xlunch/entries.dsv 0

Maybe chmod it 0644 after generation.

 - What prevents you from doing that in install?

cp -rp svgicons/ %{_datadir}/%{name}/ 2>/dev/null || :




Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License". 42 files have unknown
     license. Detailed output of licensecheck in
     /home/bob/packaging/review/xlunch/review-xlunch/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: xlunch-4.5.4-2.fc34.x86_64.rpm
          xlunch-debuginfo-4.5.4-2.fc34.x86_64.rpm
          xlunch-debugsource-4.5.4-2.fc34.x86_64.rpm
          xlunch-4.5.4-2.fc34.src.rpm
xlunch.x86_64: E: non-readable /etc/xlunch/entries.dsv 0
xlunch.x86_64: W: no-manual-page-for-binary genentries
xlunch.x86_64: W: no-manual-page-for-binary genentries.desktop.sh
xlunch.x86_64: W: no-manual-page-for-binary updateentries
xlunch.x86_64: W: no-manual-page-for-binary xlunch
xlunch.x86_64: W: dangerous-command-in-%post cp
4 packages and 0 specfiles checked; 1 errors, 5 warnings.

Comment 10 Artem 2020-11-12 15:47:48 UTC
>  - There's an issue with entries.dsv
> 
> 
> xlunch.x86_64: E: non-readable /etc/xlunch/entries.dsv 0
> 
> Maybe chmod it 0644 after generation.

Fixed (i hope).

>  - What prevents you from doing that in install?
> 
> cp -rp svgicons/ %{_datadir}/%{name}/ 2>/dev/null || :

Icons should generated on end user machine.

https://download.copr.fedorainfracloud.org/results/atim/xlunch/fedora-33-x86_64/01767037-xlunch/xlunch.spec
https://download.copr.fedorainfracloud.org/results/atim/xlunch/fedora-33-x86_64/01767037-xlunch/xlunch-4.5.4-3.fc33.src.rpm


Note You need to log in before you can comment on or make changes to this bug.